;
; lastmeasure.asm - YHBT
;

bits 32
_start:
    ; Clean up upon arrival
    push cs
    pop ds

    ; Display the YHBT message
    lea esi, [msg]
    call print_str

    ; Set video mode
    mov eax,13h
    int 10h

    push 0a000h
    pop es ; VGA screen segment
    push 0 ; Image index

mainloop:
    mov ecx, 0 ; Why do I need this?!

    pop edx
    add edx, 1
    push edx
    sub edx, 1
    and edx, 7
    add edx, 1
    shl edx, 12 ; Compute our segment
    push edx
    pop ds

    ; Blank palette
;    mov edx,3c8h
;    mov al,0
;    out dx,al
;    inc dx
;    mov ecx,256*3
;blankpal:
;    out dx,al
;    loop blankpal

    ; Clear screen
    xor edi,edi ; VGA screen address = 0
    mov eax, 00000000
    mov ecx,(320*200)/4 ; word count
    rep stosw

    ; Set palette
    mov edx,3c8h
    mov al,0
    out dx,al
    inc dx
    mov ecx,256*3
    mov esi,palette
setpal:
    lodsb
    shr al,2    ; vga palette is 6-bit
    out dx,al
    loop setpal

    ; Display picture
    xor edi,edi ; VGA screen address = 0
    mov esi,image ; source address
    mov ecx,(320*200)/4 ; word count
    rep movsw

;    ; Wait 32 VBL
;    mov ecx, 020h
;waitvbl:
;    mov edx,3dah
;s1: in al,dx
;    test al,8h
;    jnz s1
;s2: in al,dx
;    test al,8h
;    jz s2
;    loop waitvbl

    ; This will slow down emulators
    mov ecx, 07fffh
wait1:
    push ecx
    mov ecx, 0ffh
wait2:
    loop wait2
    pop ecx
    loop wait1

    ; This will slow down real computers
    mov ah,86h
    mov ecx,0
    mov edx,5000 ; sleep half a second
    int 15h

    jmp mainloop

print_str:
    nop
    ret
    mov ah, 0Eh
print:
    mov al, [es:di]
    cmp al, 0
    jz done
    int 10h
    inc si
    jmp print
done:
    ret

msg:
    db "LOL YHBT YHL", 13, 10, "HAND", 13, 10, 0

; Pad to 64k
times (64*1024 - 320*200 - 3*256 - (_start - $)) db 0
palette:
    %include "hello.jpg.raw.pal"
image:
    incbin "hello.jpg.raw",0,320*200

    times (64*1024 - 320*200 - 3*256) / 4 dw 'GNAA'
    %include "christmas.jpg.raw.pal"
    incbin "christmas.jpg.raw",0,320*200

    times (64*1024 - 320*200 - 3*256) / 4 dw 'GNAA'
    %include "harlequin.jpg.raw.pal"
    incbin "harlequin.jpg.raw",0,320*200

    times (64*1024 - 320*200 - 3*256) / 4 dw 'GNAA'
    %include "lemonparty.jpg.raw.pal"
    incbin "lemonparty.jpg.raw",0,320*200

    times (64*1024 - 320*200 - 3*256) / 4 dw 'GNAA'
    %include "loopback.jpg.raw.pal"
    incbin "loopback.jpg.raw",0,320*200

    times (64*1024 - 320*200 - 3*256) / 4 dw 'GNAA'
    %include "pillowfight.jpg.raw.pal"
    incbin "pillowfight.jpg.raw",0,320*200

    times (64*1024 - 320*200 - 3*256) / 4 dw 'GNAA'
    %include "pooped.jpg.raw.pal"
    incbin "pooped.jpg.raw",0,320*200

    times (64*1024 - 320*200 - 3*256) / 4 dw 'GNAA'
    %include "tub.jpg.raw.pal"
    incbin "tub.jpg.raw",0,320*200

the_end equ ($-_start)
size_in_sectors equ ((the_end - the_end % 512)/512+1)
times (size_in_sectors*512)-($-$$) db 0 ; pad the file so it fills the last disc sector

